<template>
    <div class="container">
      <input type="text" class="form-control" v-model="userInput" @keyup.enter="addNewTodo" placeholder="할일을 입력하고 엔터"/>
      <div class="list-group mb-4">
        <template>
          <!-- <button class="list-group-item text-left" v-for="todo in targetTodoList" :key=todo.id @click="() => {toggleTodoState(todo)}">
            {{todo.label}}
          </button> -->
          <todo-item v-for="todo in targetTodoList" :key=todo.id :todo="todo" @todoClick="() => {toggleTodoState(todo)}" />
        </template>
      </div>
      <div class="text-right">
        <button class="btn btn-sm" data-state="active" @click="changeTargetState('active')">할일</button>
        <button class="btn btn-sm" data-state="done" @click="changeTargetState('done')">완료</button>
        <button class="btn btn-sm" data-state="all" @click="changeTargetState('all')">전체</button>
      </div>
    </div>
</template>
<script>

import TodoItem from './TodoItem.vue';

export default {
//   name: 'TodoList',
  data() {
    return {
      idSelector: 0,
      userInput: '',
      todoList: [],
      targetState: 'active',
    }
  },
  components: {
    TodoItem: TodoItem
  },
  methods: {
      addNewTodo() {
          this.todoList.push({
            id: ++this.idSelector,
            label: this.userInput,
            isActive: true,
          });
          this.userInput = '';
      },
      changeTargetState(state) {
        this.targetState = state;
      },
      toggleTodoState(todo) {
        todo.isActive = !todo.isActive;
      }
  },
  computed: {
    targetTodoList() {
      if(this.targetState === 'all') {
        return this.todoList;
      }
      const isActive = this.targetState === 'active';
      return this.todoList.filter(todo => todo.isActive === isActive);
    }
  }
}
</script>
<style scope>
  @import "https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/css/bootstrap.min.css";
</style>